﻿Public Class FrmItemAssignDevice
    Friend ItemId As Integer = 0
    Private ApFirstname As String = String.Empty
    Private ApLastname As String = String.Empty

    Private Sub CloseForm(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode.Equals(Keys.Escape) Then
            Me.Close()
        End If
    End Sub

    Public Sub AssignDevice(ByVal sender, ByVal e)
        Dim Dptid = GetSingleValue(String.Format("CALL DptGetOneById('{0}')", ComboDpt.Text))
        Dim AreaId = GetSingleValue(String.Format("CALL AreaGetOneById('{0}')", ComboArea.Text))

        Try
            Query("CALL ItemRemoveUnassigned()")

            Dim InputGroupCode = ComboPc.Text.Split("-")
            Dim InputGroupCodeName = InputGroupCode(0)
            Dim InputGroupCodeNum = InputGroupCode(1)
            Dim ItemGroupCode = GetSingleValue(String.Format("CALL ItemGroupGetIdByCode('{0}', {1}, {2}, {3}, {4})", InputGroupCodeName, InputGroupCodeNum, DefaultAcademicYearId, Dptid, AreaId))

            'Set the item to be assigned
            Query(String.Format("CALL ItemAssign({0})", FrmMainItem.DtgItem.CurrentRow.Cells("id").Value))
            Query("Assigned item successfully to " & ComboDpt.Text & " " & ComboArea.Text, String.Format("CALL ItemGroupAddItem({0}, {1}, {2}, {3}, '{4}', {5})", DefaultAcademicYearId, Dptid, AreaId, ItemId, InputGroupCodeName, InputGroupCodeNum))

            'Set all history on assigning of item
            With FrmMainItem.DtgItem.CurrentRow
                Dim AssignDeviceHistory = String.Format("Assigned {0} {1} {2} to {3} {4} {5}", .Cells("Type").Value, .Cells("Brand").Value, .Cells("Model").Value, ComboDpt.Text, ComboArea.Text, ComboPc.Text)
                HistoryLogger.Log(AssignDeviceHistory, UserId, "Assignment")
            End With
        Catch ex As Exception
            If ex.Message.Contains("instance of an object") Or _
                ex.Message.Contains("Index was outside the bounds") Then

                MessageBox.Show("There is no item selected to be assigned." & vbNewLine & "Try selecting an item or add a new item if there are no items.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Else

                MessageBox.Show(ex.Message, PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            End If
        End Try

        FrmMainItem.BtnRefresh.PerformClick()

        Close()
    End Sub

    Private Sub FrmItemAssignDevice_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        SetAutoCompletion(String.Format("CALL DptGetAllNameByAyId({0})", DefaultAcademicYearId), ComboDpt)
    End Sub

    Private Sub ComboDpt_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboDpt.SelectedIndexChanged
        SetAutoCompletion(String.Format("CALL AreaGetAllDepartment({0}, '{1}')", DefaultAcademicYearId, ComboDpt.Text), ComboArea)
    End Sub

    Private Sub BtnAssign_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAssign.Click
        AssignDevice(sender, e)
    End Sub

    Private Sub ComboArea_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboArea.SelectedIndexChanged
        Dim Dptid = GetSingleValue(String.Format("CALL DptGetOneById('{0}')", ComboDpt.Text))
        Dim AreaId = GetSingleValue(String.Format("CALL AreaGetOneById('{0}')", ComboArea.Text))

        SetAutoCompletion(String.Format("CALL ItemGroupGetAllNoId({0}, {1}, {2})", DefaultAcademicYearId, Dptid, AreaId), ComboPc)
    End Sub
End Class