﻿Public Class FrmMainAy

    ''' <summary>
    ''' The selected acamedic in the datagridview.
    ''' </summary>
    ''' <remarks>The selected academic year in the datagridview.</remarks>
    Private SelectedAcademicYear As String = ""

    ''' <summary>
    ''' The query that is going to be used in saving A.Y. into the database.
    ''' </summary>
    ''' <remarks>The query for saving A.Y. into the database.</remarks>
    Private SaveAyQuery As String = ""

    ''' <summary>
    ''' The academic that is type from the user.
    ''' </summary>
    ''' <remarks>The typed A.Y. of the user.</remarks>
    Private TypedAcademicYear As String = ""

    Private Sub FrmMainAy_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        Main.ComboAy.Text = DefaultAcademicYear
    End Sub

    Private Sub CloseForm(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode.Equals(Keys.Escape) Then
            Me.Close()
        End If
    End Sub

    Private Sub TxtStartingYear_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TxtStartingYear.KeyDown

        If e.KeyCode = Keys.Enter Then
            BtnSave.PerformClick()
        End If
    End Sub

    Private Sub TxtStartingYear_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TxtStartingYear.TextChanged

        If Not IsNumeric(TxtStartingYear.Text) Then
            TxtStartingYear.Clear()
        ElseIf TxtStartingYear.Text.Length.Equals(4) Then
            If Val(TxtStartingYear.Text) < 2000 Then
                MessageBox.Show("An academic starting year must be greater than or equal to 21st century.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Hand)
                TxtStartingYear.Clear()
            Else
                TxtYearLimit.Text = Val(TxtStartingYear.Text) + 1
            End If
        Else
            TxtYearLimit.Clear()
        End If
        If TxtStartingYear.Text.Equals(String.Empty) Then
            SelectedAcademicYearId = 0
            ClearAllFields(GrpAyDetails)
        End If
    End Sub

    Private Sub BtnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSave.Click

        TypedAcademicYear = TxtStartingYear.Text & "-" & TxtYearLimit.Text

        If SelectedAcademicYearId = 0 Then

            If TxtStartingYear.Text.Length < 4 Then

                MessageBox.Show("Please fill in the the starting academic year." & vbCrLf & "The starting academic year you type is maybe incorrect." & vbCrLf & "Please try again.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Hand)
            Else
                '=====================================================
                'Saving of academic year and setting as default or not
                '=====================================================

                If SelectedAyDefaults.Equals("Yes") Then

                    Query("CALL AyClearDefaults()")
                    SaveAyQuery = String.Format("CALL AyAddAndDefault('{0}', 1)", TypedAcademicYear)
                    Query("Added new academic year successfully.", SaveAyQuery)

                    HistoryLogger.Log(String.Format("Added new academic year: {0} and set as default.", TypedAcademicYear), UserId, "Management")
                ElseIf Not SelectedAyDefaults.Equals("No") Then

                    MessageBox.Show("Please select if the academic year is set to default or not.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
                Else

                    SaveAyQuery = String.Format("CALL AyAddAndDefault('{0}', 0)", TypedAcademicYear)
                    Query("Added new academic year successfully.", SaveAyQuery)

                    HistoryLogger.Log(String.Format("Added new academic year: {0}.", TypedAcademicYear), UserId, "Management")
                End If

                If SaveAyQuery.Contains("AyAddAndDefault") Then
                    BtnAddNew.PerformClick()
                End If

            End If

        Else
            '===================================================
            'Updates academic year and setting of default or not
            '===================================================

            Dim UpdateAyQuery As String = ""
            Dim ConfirmUpdate = MessageBox.Show("Are you sure to update academic year " & TypedAcademicYear & "?", PROGRAM_NAME, MessageBoxButtons.YesNo, MessageBoxIcon.Question)

            'Confirm the user if he is sure to update a certain AY
            If ConfirmUpdate = Windows.Forms.DialogResult.Yes Then

                If SelectedAyDefaults.Equals("Yes") Then

                    Query("CALL AyClearDefaults()")
                    UpdateAyQuery = String.Format("CALL AyUpdate({0}, '{1}', 1)", SelectedAcademicYearId, TypedAcademicYear)

                    HistoryLogger.Log(String.Format("Academic year {0} is set as default", SelectedAcademicYear), UserId, "Management")
                Else

                    UpdateAyQuery = String.Format("CALL AyUpdate({0}, '{1}', 0)", SelectedAcademicYearId, TypedAcademicYear)

                    If SelectedAcademicYear IsNot TypedAcademicYear Then

                        HistoryLogger.Log(String.Format("Academic year is updated from {0} to {1}", SelectedAcademicYear, TypedAcademicYear), UserId, "Management")
                    End If
                End If

                Query("Updated academic year successfully.", UpdateAyQuery)
            End If

            BtnAddNew.PerformClick()
        End If

        If SelectedAyDefaults.Equals(String.Empty) = False Then
            DefaultAcademicYear = TypedAcademicYear
            DefaultAcademicYearId = Val(GetSingleValue("CALL AyGetDefaultId()"))

            'Set the status strip label equals to default AY
            Main.SsLblAy.Text = "Currently working on " & DefaultAcademicYear & " academic year"

            LblDefaultAy.Text = "The default A.Y. is " & DefaultAcademicYear
        End If

        FrmMainAy_Load(sender, e)
    End Sub

    Private Sub FrmMainAy_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        LblDefaultAy.Text = "The default A.Y. is " & DefaultAcademicYear

        SelectedAcademicYearId = 0

        Query("CALL AyGetAll()", DtgAy)
    End Sub

    Private Sub BtnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddNew.Click

        RadYesDefault.Enabled = True
        RadNotDefault.Enabled = True
        SelectedAcademicYearId = 0

        ClearAllFields(GrpAyDetails)

        TxtStartingYear.Focus()
    End Sub

    Private Sub DtgAy_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DtgAy.CellClick

        SelectedAcademicYear = DtgAy.CurrentRow.Cells("Academic Year").Value
        Dim SelectedStartingAy As String = SelectedAcademicYear.Split("-")(0)
        Dim SelectedLimitAy As String = SelectedAcademicYear.Split("-")(1)
        SetAyDefault = GetSingleValue(String.Format("CALL AyConfirmDefault('{0}')", SelectedAcademicYear))

        SelectedAcademicYearId = DtgAy.CurrentRow.Cells("id").Value

        TxtStartingYear.Text = SelectedStartingAy
        TxtYearLimit.Text = SelectedLimitAy

        If SetAyDefault = DefaultAcademicYear Then
            RadYesDefault.Checked = True
        Else
            RadNotDefault.Checked = True
        End If

        RadYesDefault.Enabled = False
        RadNotDefault.Enabled = False
    End Sub

    Private Sub BtnSetDefault_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSetDefault.Click

        If SelectedAcademicYear.Equals(String.Empty) = False Then

            If Not SelectedAyDefaults = "Yes" Then

                LblDefaultAy.Text = "The default A.Y. is " & DefaultAcademicYear
                TypedAcademicYear = TxtStartingYear.Text & "-" & TxtYearLimit.Text

                Query("CALL AyClearDefaults()")
                Dim UpdateAyQuery As String = String.Format("CALL AyUpdate({0}, '{1}', 1)", SelectedAcademicYearId, SelectedAcademicYear)
                Query(String.Format("Updated academic year {0} is set as default successfully", SelectedAcademicYear), UpdateAyQuery)

                DefaultAcademicYear = SelectedAcademicYear
                DefaultAcademicYearId = Val(GetSingleValue("CALL AyGetDefaultId()"))

                HistoryLogger.Log(String.Format("Academic year {0} is set as default", SelectedAcademicYear), UserId, "Management")

                ClearAllFields(GrpAyDetails)
                FrmMainAy_Load(sender, e)
            Else

                MessageBox.Show(String.Format("The academic year {0} is already set as default.", SelectedAcademicYear), PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Hand)
            End If
        Else
            MessageBox.Show("Please select academic year that will be updated first!", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Hand)
        End If

        BtnAddNew.PerformClick()
        'Set the labels equals to default AY
        Main.SsLblAy.Text = "Currently working on " & DefaultAcademicYear & " academic year"
        Main.ComboAy.Text = DefaultAcademicYear
    End Sub

    Private Sub RadYesDefault_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadYesDefault.CheckedChanged, RadNotDefault.CheckedChanged

        If RadYesDefault.Checked Then
            SelectedAyDefaults = RadYesDefault.Text
        ElseIf RadNotDefault.Checked Then
            SelectedAyDefaults = RadNotDefault.Text
        Else
            SelectedAyDefaults = String.Empty
        End If
    End Sub

End Class