﻿Public Class FrmMainAp

    ''' <summary>
    ''' The id of the accountable person when it is clicked on datagridview.
    ''' </summary>
    ''' <remarks>The id of the accountable person when it is clicked on datagridview.</remarks>
    Private ApId As Integer = 0, AreaId As Integer = 0

    Private Sub CloseForm(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode.Equals(Keys.Escape) Then
            Me.Close()
        End If
    End Sub

    Private Sub BtnAssignArea_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAssignArea.Click
        Dim AddAreaTitle As String = "Add area to accountable person"
        FrmMainArea.Text = AddAreaTitle
        FrmMainArea.LblTitle.Text = AddAreaTitle
        FrmMainArea.ShowDialog()
    End Sub

    Private Sub BtnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSave.Click
        If TxtFirstname.Text.Equals(String.Empty) And _
            TxtLastname.Text.Equals(String.Empty) And _
            TxtLastname.Text.Equals(String.Empty) Then

            MessageBox.Show("Please fill in all the details needed.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
        Else
            If TxtArea.Text.Equals(String.Empty) Then
                MessageBox.Show("Please select or put based on where the accountable person will be assigned.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
            Else
                AreaId = GetSingleValue(String.Format("CALL AreaGetOneById('{0}')", TxtArea.Text))

                If ApId = 0 Then
                    Query("Added new accountable person successfully.", String.Format("CALL ApAdd({0}, '{1}', '{2}')", AreaId, TxtFirstname.Text, TxtLastname.Text))
                Else
                    Query("Updated accountable person successfully.", String.Format("CALL ApUpdate({0}, '{1}', '{2}', {3})", AreaId, TxtFirstname.Text, TxtLastname.Text, ApId))
                End If
            End If
        End If

        BtnAddNew.PerformClick()
        FrmMainAp_Load(sender, e)
    End Sub

    Private Sub FrmMainAp_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If UserType = "staff" Then
            TxtFirstname.Text = UserFirstname
            TxtLastname.Text = UserLastname
        End If

        Query("CALL ApGetAll()", DtgAp)
    End Sub

    Private Sub BtnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddNew.Click
        ApId = 0
        ClearAllFields(GrpAccountablePeople)
    End Sub

    Private Sub DtgAp_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DtgAp.CellClick

        ApId = DtgAp.CurrentRow.Cells("id").Value
        TxtFirstname.Text = DtgAp.CurrentRow.Cells("First name").Value
        TxtLastname.Text = DtgAp.CurrentRow.Cells("Last name").Value
        TxtArea.Text = DtgAp.CurrentRow.Cells("Area/s Assigned").Value
    End Sub

    Private Sub TxtFirstname_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TxtFirstname.KeyDown, TxtLastname.KeyDown, TxtArea.KeyDown
        If e.KeyCode = Keys.Enter Then
            BtnSave.PerformClick()
        End If
    End Sub
End Class