﻿Public Class FrmMainArea
    ''' <summary>
    ''' The area id based on the datagridview selected.
    ''' </summary>
    ''' <remarks>Area id of datagridview selected.</remarks>
    Private AreaId As Integer = 0

    ''' <summary>
    ''' The area name based on the datagridview selected.
    ''' </summary>
    ''' <remarks>Area name of datagridview selected.</remarks>
    Private AreaName As String = String.Empty

    Private Sub CloseForm(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode.Equals(Keys.Escape) Then
            Me.Close()
        End If
    End Sub

    Private Sub FrmMainArea_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        If Me.Text.Equals("Manage Areas") Then
            DtgAreas.Dock = DockStyle.None
            GrpAreaDetails.Show()
        Else
            DtgAreas.Dock = DockStyle.Fill
            GrpAreaDetails.Hide()
        End If

        Query(String.Format("CALL AreaGetAll('{0}')", DefaultAcademicYearId), DtgAreas)
        SetAutoCompletion(String.Format("CALL DptGetAllNameByAyId({0})", DefaultAcademicYearId), ComboAreaDpt)
    End Sub

    Private Sub BtnSave_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnSave.Click
        If TxtAreaName.Text.Equals(String.Empty) And _
            ComboAreaDpt.Text.Equals(String.Empty) Then

            MessageBox.Show("Please fill all the needed data.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
        Else

            If AreaId = 0 Then

                Query("Added new area successfully!", String.Format("CALL AreaAdd('{0}', '{1}', {2})", TxtAreaName.Text, ComboAreaDpt.Text, DefaultAcademicYearId))
                BtnAddNew.PerformClick()
            Else

                Dim NoSpaceAreaName = ClearAllSpaces(AreaName)
                Dim NoSpaceTxtAreaName = ClearAllSpaces(TxtAreaName.Text)

                'If NoSpaceAreaName.Equals(NoSpaceTxtAreaName) Then

                '    MessageBox.Show("Laboratory specificied already exist.", PROGRAM_NAME, MessageBoxButtons.OK, MessageBoxIcon.Warning)
                'Else

                Query("Updated area successfully!", String.Format("CALL AreaUpdate('{0}', '{1}', {2})", TxtAreaName.Text, ComboAreaDpt.Text, AreaId))
                BtnAddNew.PerformClick()
                'End If
            End If
        End If

        Main.ComboDpt_SelectedIndexChanged(sender, e)
        FrmMainArea_Load(sender, e)
    End Sub

    Private Sub BtnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddNew.Click

        AreaId = 0

        ClearAllFields(GrpAreaDetails)
    End Sub

    Private Sub DtgAreas_CellClick(ByVal sender As System.Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DtgAreas.CellClick

        AreaName = DtgAreas.CurrentRow.Cells("Area Name").Value

        AreaId = DtgAreas.CurrentRow.Cells("id").Value
        TxtAreaName.Text = AreaName
        ComboAreaDpt.Text = DtgAreas.CurrentRow.Cells("Under in the department of").Value
    End Sub

    Private Sub TxtAreaName_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles TxtAreaName.KeyDown, ComboAreaDpt.KeyDown

        If e.KeyCode = Keys.Enter Then

            BtnSave.PerformClick()
        End If
    End Sub

End Class