﻿Public Class FrmMainItem
    Dim Dptid As Integer = 0
    Dim AreaId As Integer = 0
    Private Sub EditItem()
        Dim LblEditItem = String.Empty
        With DtgItem.CurrentRow
            LblEditItem = "Edit Item: " & .Cells("Type").Value & " " & .Cells("Brand").Value & " " & .Cells("Model").Value
            FrmManipItem.Text = LblEditItem
            FrmManipItem.LblTitle.Text = LblEditItem
            FrmManipItem.ItemId = .Cells("id").Value
            FrmManipItem.ComboType.Text = .Cells("Type").Value
            FrmManipItem.ComboModel.Text = .Cells("Model").Value
            FrmManipItem.ComboBrand.Text = .Cells("Brand").Value
            FrmManipItem.TxtSerial.Text = .Cells("Serial Number").Value
            FrmManipItem.TxtDescription.Text = .Cells("Description").Value

        End With
        FrmManipItem.ShowDialog()
    End Sub

    Private Sub CloseForm(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        If e.KeyCode.Equals(Keys.Escape) Then
            Me.Close()
        End If
    End Sub

    Private Sub CalculateItemAge()
        Dim ItemAge = Nothing
        Dim NumberOfDaysInYear = Nothing

        For Each Row As DataGridViewRow In DtgItem.Rows
            ItemAge = DateDiff(DateInterval.Year, CDate(Row.Cells("Date Received").Value), Date.Now)

            If Date.IsLeapYear(CDate(Row.Cells("Date Received").Value).Year) Then
                NumberOfDaysInYear = 366
            Else
                NumberOfDaysInYear = 365
            End If
            ItemAge = ItemAge / NumberOfDaysInYear

            If ItemAge < 1 Then
                Row.Cells("Age").Value = "New(" & Math.Round(ItemAge, 1) & " year old)"
            ElseIf ItemAge >= 1 Then
                Row.Cells("Age").Value = Math.Round(ItemAge, 1) & " years old"
            End If
        Next
    End Sub

    Private Sub GenerateItemCode()
        Dim DeviceNum = Main.DtgItem.CurrentRow.Cells("Item Code").Value.ToString.Split("-")(1)
        Dim AreaAssigned = Main.ComboArea.Text.Split(" ")(0).ToLower
        Dim AreaCode = Main.ComboArea.Text.Split(" ")(1)
        Dim ItemType = Nothing
        Dim ItemCode = ""

        If Not LblTitle.Text.Equals("Manage Items") Then
            For Each Row As DataGridViewRow In DtgItem.Rows
                ItemType = Row.Cells("Type").Value.ToString.Substring(0, 1).ToLower
                ItemCode = ItemType & DeviceNum & "-" & AreaAssigned & AreaCode
                Row.Cells("Itemcode").Value = ItemCode
            Next
        End If
    End Sub

    Private Sub BtnAddNew_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAddNew.Click
        FrmManipItem.ItemId = 0
        FrmManipItem.Text = "Add New Item"
        FrmManipItem.LblTitle.Text = "Add New Item"
        FrmManipItem.ShowDialog()
    End Sub

    Friend Sub FrmMainItem_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dptid = GetSingleValue(String.Format("CALL DptGetOneById('{0}')", Main.ComboDpt.Text))
        AreaId = GetSingleValue(String.Format("CALL AreaGetOneById('{0}')", Main.ComboArea.Text))


        If LblTitle.Text.Equals("Manage Items") Then
            If DtgItem.Columns.Contains("Itemcode") Then
                DtgItem.Columns.Remove("Itemcode")
            End If

            Query("CALL ItemGetAll()", DtgItem)
        Else
            DtgItem.DataSource = Nothing
            Dim ItemGroupName = Main.ItemCode.Split("-")(0)
            Dim ItemGroupNum = Main.ItemCode.Split("-")(1)
            Query(String.Format("CALL ItemGroupGetAllItems({0}, {1}, {2}, '{3}', {4})", DefaultAcademicYearId, Dptid, AreaId, ItemGroupName, ItemGroupNum), DtgItem)

            If Not DtgItem.Columns.Contains("Itemcode") Then
                DtgItem.Columns.Add("Itemcode", "Itemcode")
                GenerateItemCode()
            End If
            GenerateItemCode()
        End If

        If Not DtgItem.Columns.Contains("Age") Then
            DtgItem.Columns.Add("Age", "Age")
            CalculateItemAge()
        Else
            CalculateItemAge()
        End If
    End Sub

    Private Sub DtgItem_CellClick(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DtgItem.CellDoubleClick
        EditItem()
    End Sub

    Private Sub BtnAssignDevice_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnAssignDevice.Click
        Try
            With DtgItem.CurrentRow
                FrmItemAssignDevice.LblTitle.Text = "Assign device: " & .Cells("Type").Value & " " & .Cells("Brand").Value & " " & .Cells("Model").Value
                FrmItemAssignDevice.ItemId = .Cells("id").Value
            End With
        Catch ex As Exception

        End Try

        FrmItemAssignDevice.ShowDialog()
    End Sub

    Private Sub EditToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EditToolStripMenuItem.Click
        EditItem()
    End Sub

    Private Sub AssignDeviceToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AssignDeviceToolStripMenuItem.Click
        BtnAssignDevice.PerformClick()
    End Sub

    Private Sub DtgItem_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles DtgItem.KeyDown
        If e.KeyCode = Keys.Enter Then
            EditItem()
        End If
    End Sub

    Private Sub BtnReferesh_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtnRefresh.Click
        FrmMainItem_Load(sender, e)
    End Sub

    Private Sub BtnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        PrintReport(String.Format("CALL ItemGroupGetAllItemByCategory({0}, {1}, {2})", DefaultAcademicYearId, Dptid, AreaId), "AllItemsByAy", PrintItems.RptViewer)
        PrintItems.ShowDialog()
    End Sub
End Class