﻿Imports MySql.Data.MySqlClient

Public Class HistoryLogger

    Sub New()

    End Sub


    ''' <summary>
    ''' Executes the log subroutine in this(HistoryLogger) class.
    ''' </summary>
    ''' <param name="ActionPerformed">The message that will be save into the database.</param>
    ''' <param name="UserId">The id of the user that performed a particular activity.</param>
    ''' <param name="LogType">The type of log that is going to be save.</param>
    ''' <remarks>It executes the log subroutine for saving history.</remarks>
    Sub New(ByVal ActionPerformed As String, ByVal UserId As Integer, ByVal LogType As String)
        Log(ActionPerformed, UserId, LogType)
    End Sub

    ''' <summary>
    ''' Saves a log or history to the database.
    ''' </summary>
    ''' <param name="ActionPerformed">The message that will be saved into the history.</param>
    ''' <param name="UserId">The id of the user that performed a particular activity</param>
    ''' <param name="LogType">The type of log that is going to be save.</param>
    ''' <remarks>Saves history into the database</remarks>
    Public Shared Sub Log(ByVal ActionPerformed As String, ByVal UserId As Integer, ByVal LogType As String)
        Query(String.Format("CALL HistoryAdd('{0}', {1}, '{2}')", ActionPerformed, UserId, LogType))
    End Sub
End Class
